//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DarkGray
#property indicator_color2  DarkGray
#property indicator_color3  DeepSkyBlue
#property indicator_color4  PaleVioletRed
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_style2  STYLE_DOT
#property indicator_minimum 0
#property indicator_maximum 100

//
//
//
//
//

extern int    Length          = 32;
extern int    Smooth          =  3;
extern int    Signal          =  9;
extern int    SignalMode      = MODE_EMA;
extern int    Price           =  0;
extern double HighLowStep     = 0.5;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

double stoch[];
double signal[];
double max[];
double min[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,stoch);
   SetIndexBuffer(1,signal);
   SetIndexBuffer(2,max);
   SetIndexBuffer(3,min);
   SetIndexBuffer(4,trend);
      IndicatorShortName("Corridor stochastic ("+Length+","+Signal+","+Smooth+")");
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      stoch[i]  = iStochastic(NULL,0,Length,Signal,Smooth,SignalMode,Price,MODE_MAIN  ,i);
      signal[i] = iStochastic(NULL,0,Length,Signal,Smooth,SignalMode,Price,MODE_SIGNAL,i);
      max[i]    = MathMax(stoch[i],max[i+1]-HighLowStep);
      min[i]    = MathMin(stoch[i],min[i+1]+HighLowStep);
      
      //
      //
      //
      //
      //
      
      trend[i] = trend[i+1];
         if (stoch[i]==max[i]) trend[i] =  1;
         if (stoch[i]==min[i]) trend[i] = -1;
   }         
   manageAlerts();
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" corridor stochastic trend changed to "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" corridor stochastic",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

